
<div id="eta"> 
  <h3 id="h3_eta"><%= link_to "E-Smart Operator","#",style: "color: white;text-decoration:none;"%></h3>
  <div class="table-responsive" >
    <table class="table table-striped table-hover table-bordered tbl_stage_details_report" id="tbl_eta">
      <thead class="bg-gray" class="table_header">
        <tr>
          <th>Vehicle</th>
          <th>Service no</th> 
          <th>Origin-Destination</th>
          <!-- <th>Prev. Stage Details</th> -->
          <th>STA</th>
          <th>ETA</th>
          <th>Status</th>
        </tr>
      </thead>
    </table>
  </div>
</div>

<div class="footer_text text-center">
  <div class="fotter_inner">
    <span style="color: red">* </span>The timings displayed here should be considered as approximate. Please contact the respective bus Operators for latest Information.

   <!--  <div colspan="2"  class="footer_link text-center"><span class="cls_footer_style"><span style="color: #519AB5">© </span>2019 All Rights Reserved.</span> <span class="cls_footer_style"></span> <span class="cls_footer_style">Maintained by <span style="color: #519AB5"> E-Smart Operator</span></div> --></span>
  </div>
</div>

<script type="text/javascript">
  var interval = null
  place_id = ''
  //vehicle_type = ''
  time_limit = 30000
  var eta_data = null
  var header_color = "<%= params[:color].present? ? params[:color] : 'fc0' %>"
  var pageLength = 8
  var marquee_length = 13
  var columns_width = [{ "width": "20%" },{ "width": "15%" },{ "width": "23%" },{ "width": "12%" },{ "width": "12%" },{ "width": "13%" }]

  var eta_data = [["MP 09 FA 9060", "IND0630", "", "<%= (Time.now + 10.minutes).strftime("%I:%M %p")%>", "<%= (Time.now + 12.minutes).strftime("%I:%M %p")%>", "<span onclick='changeStatus(this)' id='MP-09-FA-9060' data-ori_dest='Indore-Sonkatch'><span style='color: #51B245'>On Time<span></span></span></span>", "Khilchipur-Indore"],
  ["MP 09 FA 9232", "IND8000", "", "<%= (Time.now + 20.minutes).strftime("%I:%M %p")%>", "<%= (Time.now + 25.minutes).strftime("%I:%M %p")%>", "<span onclick='changeStatus(this)' id='MP-09-FA-9232' data-ori_dest='Indore-Sonkatch'><span style='color: #51B245'>On Time<span></span></span></span>", "Sonkatch-Indore  "],
  ["MP 09 FA 9246", "INDSJP7", "", "<%= (Time.now + 15.minutes).strftime("%I:%M %p")%>", "<%= (Time.now + 45.minutes).strftime("%I:%M %p")%>", "<span id='MP-09-FA-9246' data-ori_dest='Indore-Sonkatch'><span style='color: #FF5733'>Delayed<span></span></span></span>", "Indore-Shajapur  "],
  ["MP 09 FA 9730", "IND0730", "", "<%= (Time.now + 60.minutes).strftime("%I:%M %p")%>", "<%= (Time.now + 65.minutes).strftime("%I:%M %p")%>", "<span onclick='changeStatus(this)' id='MP-09-FA-9730' data-ori_dest='Indore-Sonkatch'><span style='color: #51B245'>On Time<span></span></span></span>", "Khilchipur-Indore"],
  ["MP 09 FA 9235", "INDSONK", "", "<%= (Time.now + 5.minutes).strftime("%I:%M %p")%>", "<%= (Time.now + 8.minutes).strftime("%I:%M %p")%>", "<span onclick='changeStatus(this)' id='MP-09-FA-9235' data-ori_dest='Indore-Sonkatch'><span style='color: #51B245'>On Time<span></span></span></span>", "Indore-Sonkatch  "],
  ["MP 09 FA 9269", "INDASTA", "", "<%= (Time.now + 30.minutes).strftime("%I:%M %p")%>", "<%= (Time.now + 60.minutes).strftime("%I:%M %p")%>", "<span id='MP-09-FA-9269' data-ori_dest='Indore-Sonkatch'><span style='color: #FF5733'>Delayed<span></span></span></span>", "Indore-Ashta (MP)"]]

  var table = $('table.tbl_stage_details_report').DataTable( {  
    'dom': 'lfBrtip',
    "order": [[ 3, "asc" ]],   
    'buttons': [
      //'csv', 'print'
      ],
    //"bPaginate": false,
    "bFilter": false,
    "pageLength": get_page_length(),
    "columns": columns_width
    // "columnDefs": [
    // {
    //   targets:[0,1,2,3,4,5,-1], // targets last column, use 0 for first column
    //   className:"cls_eta_data"
    // }
  //]
});
  var arrived_arr = [];
  var ontime_arr = [];
  var eta_hash = {};
  const artyom = new Artyom();
  //const maria = new Artyom();
  //maria.ArtyomVoicesIdentifiers["hi-IN"] = ["Google IN Hindi Female"];
  artyom.initialize({
    lang:"en-GB",
    debug:true, //Show what recognizes in the Console
    listen:true, //Start listening after this
    speed:1, // Talk a little bit slow
  });

  var ArtyomConfiguration = {
    hindi: {
      lang: "hi-IN",
      continuous: true,
      listen: true,
      debug: true
    },
    english: {
      lang: "en-GB",
      continuous: true,
      listen: true,
      debug: true
    }
  };

  artyom.ArtyomVoicesIdentifiers["en-GB"] = ["Google UK English Female"];


  function get_page_length(){
    <%if @user.present? && @user.is_privilege_enabled?(PrivilegeConstants::SHOW_PREVIOUS_STAGE_IN_TV_SCREEN) %>
    pageLength = 3
    <%end%>
    return pageLength
  }

  $(document).ready(function(){
   header_color = "<%= params[:color].present? ? params[:color] : 'fc0' %>"
   $("#h3_eta").css({"background-color": "#" + header_color});
   $('#tbl_eta thead th').off('click')
   $("#place_id").select2();
   $("#stage_filter").select2();

   //getDataWithInterval(time_limit)
    //$('.cls_stage_details_status').trigger('click');
    $(".dataTables_info").hide()
    //eta_data = <%#= @eta_data.to_json.html_safe%>
    console.log(eta_data)
    get_index_pos()
    $.each(eta_data, function( index, value ) { 
      value[0] = value[0].split("-").join(" ")   
      if (jQuery.type(value[5]) != "string"){
        data = distance_time_calc_leaflet(value[5][0], value[5][1], value[5][2], value[5][3],'K',value[5][4],value[6])
        value[5] = data[0] 
        var id = value[0].split(" ").join("-") + value[4].split(" ")[0]
        value[6] = "<span onclick='changeStatus(this)'" + "id="+id+" data-ori_dest="+value[7]+">"  + data[1] + "</span>" 
        if (eta_hash[id] != undefined)  {
          value[5] = eta_hash[id]
        }
      }
      if (value[0].length > 17){
        value[0] = '<span style="font-size: 4vh !important">' + value[0] + '</span>'
      }
      if (value[1].length > marquee_length){
        value[1] = '<marquee scrollamount="4">' + value[1] + '</marquee>'
      }
      if (value[6].length > 13){
        value[2] = '<marquee scrollamount="4">' + value[6] + '</marquee>'
      }
      if (value[3].split("").length != 8){value[3] = "0" + value[3]}
        if (value[4].split("").length != 8){value[4] = "0" + value[4]}
     // if (value[2].length > 12 && value[2].length < 19){
     //   value[2] = '<span style="font-size: 4.5vh !important">' + value[2] + '</span>'
     //  }
     //  else if (value[2].length > 19){
     //   value[2] = '<span style="font-size: 3.5vh !important">' + value[2] + '</span>'
     //  }
     if (!(value[4].indexOf('1') == -1) ){
      var sta_time = value[4].split(" ")
      if (value[4].match(/1/gi).length == 1){
        value[4] = sta_time[0] + "  &nbsp;" + sta_time[1]
      }
      else if (value[4].match(/1/gi).length == 2){
        value[4] = sta_time[0] + "  &nbsp;&nbsp;" + sta_time[1]
      }
    }

     //debugger;
     // if (!(value[5].indexOf('1') == -1) ){
     //  var eta_time = value[5].split(" ")
     //  if (value[5].match(/1/gi).length == 1){
     //    value[5] = eta_time[0] + "  &nbsp;" + eta_time[1]
     //  }
     //  else if (value[5].match(/1/gi).length == 2){
     //    value[5] = eta_time[0] + "  &nbsp;&nbsp;" + eta_time[1]
     //  }
     // }
     table.row.add(value);     
   });
    table.draw()
    $(".paginate_button ").hide()
    $(".dataTables_length").hide()
    start_auto_pagination()
    $("#text_jscolor").change(function(){
      $("#h3_eta").css({"background-color": "#" + this.value});
      this.value = ''
    })

  });

  function changeStatus(ele){
    var ele_txt = ele.value;
    var stage_data = ele.parentElement.parentElement.children    
    ori_dest = ele.dataset["ori_dest"].split("-")
    var myStr = stage_data[0].textContent
    var newStr = myStr.split(" ").join("").replace(/-/g, "").split("").join('!');
    if ($.inArray(ele.id, ontime_arr) == -1){
      //artyom.initialize(ArtyomConfiguration.english).then(function(){});
      start_announcement("E-SMART OPERATOR Service Number "+stage_data[1].textContent.split("").join('!') +" From "+ori_dest[0] + " to " + ori_dest[1]+",Bus Number "+newStr+" is expected to arrive on time.",'English')

      //artyom.initialize(ArtyomConfiguration.hindi).then(function(){});
      //start_announcement("E-SMART OPERATOR Service number ,"+stage_data[1].textContent.split("").join('!') +" "+ori_dest[0] + " se " + ori_dest[1]+" तक,Gaadi number ,"+newStr+" अपने निर्धारित समय पर चल रही है.",'Hindi')
      ontime_arr.push(ele.id)
    }
    else
    {
      ele.textContent = "ARRIVED"
      $(ele).css({"color":"#66CCFF"});
      arrived_arr.push(ele.id)    
      var time = new Date();  
      eta_hash[ele.id] = time.toLocaleString('en-US', { hour: 'numeric', minute: 'numeric', hour12: true })
      stage_data[4].textContent = eta_hash[ele.id]
      start_announcement("E-SMART OPERATOR Service Number "+stage_data[1].textContent.split("").join('!')  +", From "+ori_dest[0] + " to " + ori_dest[1]+", Bus Number "+newStr+" is arrived. Please get on-board and have a nice journey.","English")
      //start_announcement("E-SMART OPERATOR Service Number "+stage_data[1].textContent.split("").join('!')  +","+ori_dest[0] + " se " + ori_dest[1]+" तक, Bus Number "+newStr+", अपने निर्धारित समय पर आ चुकी है. कृपया bus पर जाएं और एक अच्छी यात्रा करें.","Hindi")
    }
  }


  function setTextColor(picker) {
    $("#h3_eta").css({"background-color": "#" + picker.toString()});
    header_color = picker.toString()
  }

  function get_index_pos(){   
    <%if @user.present? && !@user.is_privilege_enabled?(PrivilegeConstants::SHOW_PREVIOUS_STAGE_IN_TV_SCREEN) && !@user.is_privilege_enabled?(PrivilegeConstants::SHOW_FROM_TO_IN_TV_SCREEN)%>
    table.column( 2 ).visible(false)
    table.column( 3 ).visible(false)
    columns_width = [{ "width": "20%" },{ "width": "25%" },{ "width": "20%" },{ "width": "20%" },{ "width": "15%" }]
    marquee_length = 17
    <%elsif @user.present? && @user.is_privilege_enabled?(PrivilegeConstants::SHOW_PREVIOUS_STAGE_IN_TV_SCREEN) && !@user.is_privilege_enabled?(PrivilegeConstants::SHOW_FROM_TO_IN_TV_SCREEN)%>
    table.column( 2 ).visible(false)
    table.column( 3 ).visible(true)
    columns_width =  [{ "width": "18%" },{ "width": "22%" },{ "width": "22%" },{ "width": "20%" },{ "width": "8%" },{ "width": "10%" }]
    <%elsif @user.present? && !@user.is_privilege_enabled?(PrivilegeConstants::SHOW_PREVIOUS_STAGE_IN_TV_SCREEN) && @user.is_privilege_enabled?(PrivilegeConstants::SHOW_FROM_TO_IN_TV_SCREEN)%>
    table.column( 2 ).visible(true)
    table.column( 3 ).visible(false)
    columns_width = [{ "width": "18%" },{ "width": "22%" },{ "width": "22%" },{ "width": "20%" },{ "width": "8%" },{ "width": "10%" }]
    <%end%>  
  }

  function start_auto_pagination(){
    var pageInfo = table.page.info();
    interval = setInterval(function(){
     $(".paginate_button ").hide()
     page_no = table.page() + 1
     if(page_no === pageInfo.pages){
      $($('.paginate_button a')[1]).trigger('click')
      $('.cls_stage_details_status').trigger('click');
      $(".paginate_button ").hide()
      $(".dataTables_length").hide()
    }
    else{
      table.page( 'next' ).draw( 'page' );
      $('.cls_stage_details_status').trigger('click');
      $(".paginate_button ").hide()
      $(".dataTables_length").hide()
    }
  }, 10000);
  }
  
  function show_service_details(){
    clearInterval(interval);
    place_id = $("#place_id").val()
    stage_filter = $("#stage_filter").val()
    //vehicle_type = $("#vehicle_type").val()
    // $.ajax({
    //   url: '/eta_demo/<%#= params[:api_key]%>',
    //   type: 'GET',
    //   dataType: 'script',
    //   data: {place_id: place_id,vehicle_type: vehicle_type}
    // });
    window.location.replace("/eta_demo/<%= params[:api_key]%>?place_id=" + place_id + "&color=" + header_color + "&stage_filter=" + stage_filter);
  }



  function getDataWithInterval(time_limit){
    //debugger
    $(".loader_container").hide();
    clearInterval(interval);
    get_params()
    var interval1 = setTimeout(function () {
    //location.reload();
    $.ajax({
      url: "/eta_demo/<%= params[:api_key]%>?place_id="+place_id + "&color=" + header_color + "&stage_filter=" + stage_filter,
      type: 'GET',
      dataType: 'script',
      complete: function (data) {
        table.clear().draw()
        //eta_data = <%#= @eta_data.to_json.html_safe%>
        console.log(eta_data)
        $.each(eta_data, function( index, value ) {   
         value[0] = value[0].split("-").join(" ")   
         if (jQuery.type(value[5]) != "string"){          
          data = distance_time_calc_leaflet(value[5][0], value[5][1], value[5][2], value[5][3],'K',value[5][4],value[6])
          value[5] = data[0]  

        }

        if (value[0].length > 17){
          value[0] = '<span style="font-size: 4vh !important">' + value[0].split("-").join(" ") + '</span>'
        }
        if (value[1].length > marquee_length){
          value[1] = '<marquee scrollamount="4">' + value[1] + '</marquee>'
        }
        if (value[2].length > 13){
          value[2] = '<marquee scrollamount="4">' + value[2] + '</marquee>'
        }
        var id = value[0].split(" ").join("-") + value[4].split(" ")[0]
        if ($.inArray( id, arrived_arr) != -1){
          value[6] = "<span style='color:#66CCFF;'>ARRIVED</span>"
          value[5] = eta_hash[id]
        }
        else{
          value[6] = "<span onclick='changeStatus(this)'" + "id="+id+" data-ori_dest="+value[7]+">"  + data[1] + "</span>" 
        } 
        // if (value[3].split("").length != 8){value[3] = "0" + value[3]}
        //   if (value[4].split("").length != 8){value[4] = "0" + value[4]}
     // if (value[2].length > 12 && value[2].length < 19){
     //   value[2] = '<span style="font-size: 4.5vh !important">' + value[2] + '</span>'
     //  }
     //  else if (value[2].length > 19){
     //   value[2] = '<span style="font-size: 3.5vh !important">' + value[2] + '</span>'
     //  }

     table.row.add(value);     
   });
        //getDataWithInterval(time_limit) 
        table.draw()
        $(".paginate_button ").hide()
        $('.cls_stage_details_status').trigger('click');   
        start_auto_pagination()  
      }
    });
  },time_limit);
  }



  function distance_time_calc_leaflet(lat1, lon1, lat2, lon2, unit,avg_speed,on_time) {
    var radlat1 = Math.PI * lat1/180
    var radlat2 = Math.PI * lat2/180
    var theta = lon1-lon2
    var radtheta = Math.PI * theta/180
    var dist = Math.sin(radlat1) * Math.sin(radlat2) + Math.cos(radlat1) * Math.cos(radlat2) * Math.cos(radtheta);
    if (dist > 1) {
      dist = 1;
    }
    dist = Math.acos(dist)
    dist = dist * 180/Math.PI
    dist = dist * 60 * 1.1515
    if (unit=="K") { dist = dist * 1.609344 }
      if (unit=="N") { dist = dist * 0.8684 }
  //return dist
if (avg_speed == "0.0"){
  avg_speed = 50.0
}
else if(parseFloat(avg_speed) < 60.0){
  avg_speed = 60.0
}
time = dist/avg_speed
time = time.toString().split(".")
h = time[0]
m = parseInt(parseFloat("0." + time[1]) * 60)
var eta = new Date();
total_min = (h * 60) + m
eta.setMinutes(eta.getMinutes() + total_min);
time_in_int = Math.floor(eta.getTime()/1000)
on_time = parseInt(on_time)
eta_status = time_in_int > on_time ? '<span style="color: #FF5733">Delayed<span>' : '<span style="color: #51B245">On Time<span>'
//$(ele).text(time[0] + " h " + time[1] + " m")
 //$(ele).text(lat1.toString() + "," + lon1.toString() + "," + lat2.toString() + "," + lon2.toString() )
 return [(eta.toLocaleString('en-US', { hour: 'numeric',minute: 'numeric', hour12: true })),eta_status]
}

function open_tv_screen(){
  window.location.replace("/eta_demo/<%= params[:api_key]%>?place_id=" + place_id + "&mode=tv" + "&color=" + header_color + "&stage_filter=" + stage_filter);
}

function get_params(){
  place_id = "<%= params[:place_id]%>"
  stage_filter = "<%= params[:stage_filter]%>"
    //vehicle_type = "<%#= params[:vehicle_type]%>"
  }


  function start_announcement(msg,lang){
    var intervalId = setTimeout(function() {
      console.log(msg)
      if (lang == "Hindi"){
        artyom.initialize(ArtyomConfiguration.hindi)
      }
      else{
        artyom.initialize(ArtyomConfiguration.english)
      }
      artyom.say(msg);
    //     artyom.fatality().then(() => {
    // });
    clearInterval(intervalId);
  }, 4000);  
  }

</script>

<style type="text/css">
  .sorting_disabled
  {
   background-image:none !important;
 }
</style>
<link href="https://fonts.googleapis.com/css?family=Josefin+Sans:700" rel="stylesheet">

<style>
  @font-face {
    font-family: "Digital-7";
    src:url("<%= asset_path 'digital-7.ttf'%>");
  }
  body {
    margin: 0;
    padding: 0;
    background: #1f2025;
    color: #fff;
    font-size: 24px;
    color: #fc0;
    font-family: 'Josefin Sans', sans-serif;
  }
  table td div{
    border: 1px solid #333;
    background: linear-gradient(to right, #4b4b4b, #434343);
    float: left;

  }

  #eta td {
    /*padding: 0.5% 0 !important;*/
    font-family: "Digital-7";
    text-align: left;
    line-height: 1;
    font-size: 5.2vh;
    padding-left: 1px
    border-bottom: 1px solid #0029f8;
    color: #fc0;
    padding-left: 25px !important;
  }
  #eta tr th {
    color: #000;
    background: #fff;
    padding: 10px 0;
    text-align: center;
    text-transform: uppercase;
    padding-left: 11px;
    border: 1px solid #1f2025;
    line-height: normal;
  }
  #eta tr th:after {
    content: none;
  }
  #eta .table-hover > tbody > tr:hover {
    background: none !important;
  }
  #eta .table-striped > tbody > tr:nth-of-type(odd) {
    background: none !important;
  }
  #eta .form-group {
    color: #fff;
  }
  #eta {
    position: relative;
    height: 90%;
    overflow: hidden;
  }
  .footer_text.text-center {
    position: relative;

    height: 10%;
  }
  .fotter_inner {
    position: absolute;
    bottom: 5px;
    margin: 0 auto;
    left: 0;
    right: 0;
  }
  #eta button {
    height: 38px;
    width: 100%;
    font-size: 23px;
    line-height: normal;
  }
  #eta .form-group span.select2 .selection .select2-selection {
    border-radius: 0;
    padding-top: 4px;
  }

  h3 {
    color: #fff;
    text-align: center;
    background: #fc0;
    padding: 10px 0 2px;
    margin: 0;
    font-size: 60px;
    text-transform: uppercase;
  }
  .ontime {
    background: #0050ca;
    color: #fff;
  }
  .delay {
    background: #b51313;
    color: #fff;
  }
  .arrived {
    background: #519AB5;
    color: #fff;
  }
  .footer_text, .footer_link {
    font-family: 'Josefin Sans', sans-serif !important;
    color: #fff;
    font-size: 15px !important;
  }
  .cls_footer_style{
    padding-left: 10%
  }


</style>
